
#include once "connect.bi"
#include once "sgui\sgui.bas"
#include once "sgui\clickmapgadget.bas"
#include once "sgui\menu.bas"
#include once "stringlist.bi"
#include once "graphics.bi"
#include once "colors.bi"
#include once "arbitrator\chess.bi"
#include once "version.bi"
#include once "language.bi"
#include once "validator.bi"
#include once "engine.bi"

using sGUI
using strlist

declare sub DisplayArbitratorMessage(byval as string = "")
declare function IsPromotionMove(byref as chess.tChessGame, byval as string) as boolean
declare function IsCastlingMove(byref as chess.tChessGame, byval as string) as boolean
declare function IsEnPassantMove(byref as chess.tChessGame, byval as string) as boolean
declare function ReplaceFieldName(byval as string) as string
declare function ComparePiecePlacement(byval as string, byval as string) as boolean

ScreenRes 320, 18 + 320 + 18, 32,, 4
WindowTitle "Eschecs " & version

const textHeight = 14
dim as integer w, h
ScreenInfo w, h
Width w \ 8, h \ textHeight
SetLanguage()
dim shared as uinteger messageTextColor
dim shared as uinteger messageColor
customColors = 1
backgroundColor	= colors.white
textColor	= colors.black
gadgetColor	= colors.teagreen'lightpink
gadgetGlowColor	= colors.magenta
gadgetTextColor	= colors.black
cursorColor = colors.magenta
menuColor = colors.darkteagreen'pink
menuTextColor = colors.black
menuHiliteColor = gadgetColor
menuGhostedColor = ShiftRGB(MenuColor, -contrast / 2)
messageTextColor = textColor
messageColor = gadgetColor
graph.resourcePath = ExePath() & "\images\"
graph.boardLeft = 0
graph.boardTop = 18
InitGFX
DisplayArbitratorMessage()

dim as EventHandle ptr event = new EventHandle
dim as gadget ptr boardClickSensor  = AddClickMapGadget( _
  event, _
  graph.boardLeft, _
  graph.boardTop, _
  graph.resourcePath & "clickmap.bmp" _
)
GadgetOn(boardClickSensor)
dim as integer field_ID
type chessfield 
  fieldname as string 
  selected as integer 
  posx as integer 
  posy as integer 
end type
dim as chessfield Board(1 to 64)
for k as integer = 0 to 7 
  Board(1 + k * 8).fieldname = "a" & str(k + 1) 
  Board(2 + k * 8).fieldname = "b" & str(k + 1) 
  Board(3 + k * 8).fieldname = "c" & str(k + 1) 
  Board(4 + k * 8).fieldname = "d" & str(k + 1) 
  Board(5 + k * 8).fieldname = "e" & str(k + 1) 
  Board(6 + k * 8).fieldname = "f" & str(k + 1) 
  Board(7 + k * 8).fieldname = "g" & str(k + 1) 
  Board(8 + k * 8).fieldname = "h" & str(k + 1) 
next k

dim shared as boolean autoPlay = true
dim shared as integer autoColor = chess.cBlack

dim as integer _
  item_quit, _
  item_move, _
  item_auto, _
  item_new, _
  item_flip, _
  item_knight, _
  item_bishop, _
  item_rook, _
  item_queen

Menu              (event, 1, 0, 1, "Eschecs")
item_quit   = Menu(event, 1, 1, 1, sQuit)
Menu              (event, 2, 0, 1, sMoves)
item_move   = Menu(event, 2, 1, 1, sMove)
item_auto   = Menu(event, 2, 2, IIF(autoplay, 3, 1), sAutoplay)
Menu              (event, 3, 0, 1, sBoard)
item_new    = Menu(event, 3, 1, 1, sNew)
item_flip   = Menu(event, 3, 2, 1, sFlip)
Menu              (event, 4, 0, 1, sPromotion)
item_knight = Menu(event, 4, 1, 1, sKnight)
item_bishop = Menu(event, 4, 2, 1, sBishop)
item_rook   = Menu(event, 4, 3, 1, sRook)
item_queen  = Menu(event, 4, 4, 3, sQueen)
MenuOn(event)

graph.upsideDown = false
dim startingPosition as string = "rnbqkbnr/pppppppp/8/8/8/8/PPPPPPPP/RNBQKBNR w KQkq - 0 1"
if (len(Command(1)) > 0) andalso IsFEN(Command(1)) then startingPosition = Command(1)
dim chessboard as graph.TGraphicalChessboard
chessboard.Create()
chessboard.ChangePieces(mid(startingPosition, 1, instr(startingPosition, " ") - 1))
chessboard.RedrawPieces()
dim shared game as chess.tChessGame
dim move as string = ""
dim shared state as tGameState = gsCheckmate
dim check as boolean = false
dim history as stringlist
dim appLog as stringlist
dim rookMove as string = ""
dim promotion as integer
dim promotionCommand as string = "q"
dim shared oneMove as boolean = false
dim comesFrom as string
dim username as string = Environ("USERNAME")
dim promotionSymbol as string = "  nbrq"

#macro OnNewPosition()
history.Add(game.FEN)
game.GenerateGeometricalMoves()
game.GenerateSpecialMoves()
game.CheckMovesLegality()
state = game.GameState
if state = gsInProgress then
  var samePlacement = 0
  for i as integer = 0 to history.Count - 2
    if ComparePiecePlacement(history.Strings(i), history.Strings(history.Count - 1)) then samePlacement += 1
  next
  if samePlacement = 2 then state = gsDraw
end if
if len(move) = 4 then chessboard.MovePiece(move)
if rookMove <> "" then chessboard.MovePiece(rookMove)
if state = gsInProgress then
  check = game.Check
  DisplayArbitratorMessage(IIF(check, sCheck & " ", "") & IIF(game.activeColor = chess.cWhite, sWhiteToMove, sBlackToMove) & IIF(WaitingForChessPlayerMove(), "..", ""))
else
  DisplayArbitratorMessage(sState(state))
end if
#endmacro

#macro OnLegalMove()
if IsPromotionMove(game, move) then
  if comesFrom = username then
    if     GetChecked(event, 4, 1) then
      promotion = chess.cKnight
    elseif GetChecked(event, 4, 2) then
      promotion = chess.cBishop
    elseif GetChecked(event, 4, 3) then
      promotion = chess.cRook
    elseif GetChecked(event, 4, 4) then
      promotion = chess.cQueen
    end if
  else
    var i = instr("nbrq", mid(move, 5, 1))
    if (len(move) = 5) andalso (i > 0) then
      select case i
        case 1 : promotion = chess.cKnight
        case 2 : promotion = chess.cBishop
        case 3 : promotion = chess.cRook
        case 4 : promotion = chess.cQueen
      end select
    else
      promotion = chess.cQueen
    end if
  end if
  game.DoMove(move, promotion)
  chessboard.Promote(left(move, 2), promotionSymbol[promotion])
else
  if IsCastlingMove(game, move) then
    select case move
      case "e1g1" : rookMove = "h1f1"
      case "e1c1" : rookMove = "a1d1"
      case "e8g8" : rookMove = "h8f8"
      case "e8c8" : rookMove = "a8d8"
    end select
  elseif IsEnPassantMove(game, move) then
    chessboard.HidePiece(chr(move[2], move[1]))
  end if
  game.DoMove(move)
end if
appLog.Add(Time() & " " & move & " " & comesFrom)
#endmacro

function WaitingForChessPlayerMove() as boolean
  return _
    cbool(state = gsInProgress) _
    andalso ((autoPlay andalso cbool(autoColor = game.activeColor)) or oneMove)
end function

game.Initialize(startingPosition)
OnNewPosition()

dim engineConnected as boolean = _
  cbool(ChDir(EXEPath() & ENGPATH) = 0) _
  and Connect(ENGNAME) _
  and uci.CompileRegExpr()

dim as string vAnswer, vName, vAuthor, vUciInfo = space(20)
dim ucistatus as integer = -1

if engineConnected then
  SendCommand("uci")
  do
    Sleep(5)
    vAnswer = TryGetAnswer()
  loop until InStrRev(vAnswer, "uciok")
  if uci.ParseUciOk(vAnswer, vName, vAuthor) then
    appLog.Add("Engine name: """ & vName & """")
    appLog.Add("Engine author: """ & vAuthor & """")
  end if
  ucistatus = 0
end if

WindowTitle "Eschecs " & version & " - " & vName

do
  event->xSleep(1)
  
  if WaitingForChessPlayerMove() then
    oneMove = false
    
    select case as const ucistatus
      case 0
        SendCommand("position fen " & game.FEN)
        ucistatus += 1
      case 1
        SendCommand("go movetime 500")
        ucistatus += 1
      case 2
        vAnswer = TryGetAnswer()
        if InStrRev(vAnswer, "bestmove") then
          ucistatus += 1
        end if
      case 3
        move = ExtractBestMove(vAnswer)
        ucistatus +=1
      case 4
        if cbool(len(move) >= 4) andalso game.IsLegal(move) then
          comesFrom = vName
          OnLegalMove()
          OnNewPosition()
        else
          autoPlay = false
          if GetChecked(event, 2, 2) then Menu(event, 2, 2, 1, sAutoplay)
          DisplayArbitratorMessage(IIF(game.activeColor = chess.cWhite, sWhiteToMove, sBlackToMove))
        end if
        move = ""
        rookMove = ""
        ucistatus = 0
    end select
  end if
  
  if event->GADGETMESSAGE then
    select case event->GADGETMESSAGE
      case boardClickSensor
        if state = gsInProgress then
          field_ID = getClickMapColor(boardClickSensor)
          move += IIF(graph.upsideDown, ReplaceFieldName(Board(field_ID).fieldname), Board(field_ID).fieldname)
          if len(move) = 2 then
            if game.IsLegalStartingSquare(move) then
              chessboard.Backup()
              var dest = game.LegalDestinations(move)
              screenlock
              for i as integer = 0 to Len(dest) \ 2 - 1
                chessboard.Highlight(mid(dest, 2 * i + 1, 2))
              next
              screenunlock
            else
              move = ""
            end if  
          end if
          if len(move) = 4 then
            chessboard.Restore_()
            if game.IsLegal(move) then
              comesFrom = username
              OnLegalMove()
              OnNewPosition()
            end if
            move = ""
            rookMove = ""
          end if
        end if
    end select
  end if
  
  if event->MENUMESSAGE then
    select case event->MENUMESSAGE
      case item_quit
        event->EXITEVENT = 1
      case item_move
        if autoPlay then
          autoColor = chess.cBlack * autoColor
        else
          oneMove = true
        end if
      case item_auto
        if GetChecked(event, 2, 2) then
          Menu(event, 2, 2, 1, sAutoplay)
        else
          Menu(event, 2, 2, 3, sAutoplay)
        end if
        autoPlay = GetChecked(event, 2, 2)
      case item_new
        chessboard.ClearBoard()
        chessboard.ChangePieces()
        chessboard.RedrawPieces()
        game.Initialize()
        history.ClearList
        OnNewPosition()
      case item_flip
        chessboard.ClearBoard()
        graph.upsideDown = not graph.upsideDown
        for i as integer = 0 to chessboard.number - 1
          chessboard.array(i).img.fLeft = graph.XToScreen(chessboard.array(i).fX)
          chessboard.array(i).img.fTop = graph.YToScreen(chessboard.array(i).fY)
        next i
        chessboard.RedrawPieces()
      case item_knight
        Menu(event, 4, 1, 3, sKnight)
        Menu(event, 4, 2, 1, sBishop)
        Menu(event, 4, 3, 1, sRook)
        Menu(event, 4, 4, 1, sQueen)
      case item_bishop
        Menu(event, 4, 1, 1, sKnight)
        Menu(event, 4, 2, 3, sBishop)
        Menu(event, 4, 3, 1, sRook)
        Menu(event, 4, 4, 1, sQueen)
      case item_rook
        Menu(event, 4, 1, 1, sKnight)
        Menu(event, 4, 2, 1, sBishop)
        Menu(event, 4, 3, 3, sRook)
        Menu(event, 4, 4, 1, sQueen)
      case item_queen
        Menu(event, 4, 1, 1, sKnight)
        Menu(event, 4, 2, 1, sBishop)
        Menu(event, 4, 3, 1, sRook)
        Menu(event, 4, 4, 3, sQueen)
    end select
  end if
loop until event->EXITEVENT

if engineConnected then
  SendCommand("quit")
end if

delete event
chessboard.Free
appLog.SaveToFile(EXEPath() & "\eschecs.log")

sub DisplayArbitratorMessage(byval s as string = "")
  line (0, 18 + 320)-(320, 18 + 320 + 18), messageColor, BF
  draw string (8, 18 + 320 + (18 - textHeight) \ 2), s, messageTextColor
end sub

function IsPromotionMove(byref g as chess.tChessGame, byval m as string) as boolean
  return (abs(g.board(m[0] - 96, m[1] - 48)) = chess.cPawn) andalso ((m[3] - 48 = 1) or (m[3] - 48 = 8))
end function

function IsCastlingMove(byref g as chess.tChessGame, byval m as string) as boolean
  return (abs(g.board(m[0] - 96, m[1] - 48)) = chess.cKing) andalso (Abs(m[0] - m[2]) = 2)
end function

function IsEnPassantMove(byref g as chess.tChessGame, byval m as string) as boolean
  return (abs(g.board(m[0] - 96, m[1] - 48)) = chess.cPawn) andalso ((abs(g.board(m[2] - 96, m[3] - 48)) = chess.cNothing) and (m[0] <> m[2]))
end function

function ReplaceFieldName(byval s as string) as string
  dim as ubyte asc1 = s[0] - 96, asc2 = s[1] - 48
  asc1 = 9 - asc1
  asc2 = 9 - asc2
  return chr(asc1 + 96, asc2 + 48)
end function

function ComparePiecePlacement(byval FENRecord1 as string, byval FENRecord2 as string) as boolean
  return mid(FENRecord1, 1, instr(FENRecord1, " ")) = mid(FENRecord2, 1, instr(FENRecord2, " "))
end function
